﻿Public Class MdiForm

    Private Sub UltraToolbarsManager1_ToolClick(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinToolbars.ToolClickEventArgs) Handles UltraToolbarsManager1.ToolClick
        Select Case e.Tool.Key
            Case "ButtonTool1"

                Dim oChildForm As Form1

                oChildForm = ShowChildFormCheck("Form1")

                If oChildForm Is Nothing Then
                    oChildForm = New Form1
                    oChildForm.MdiParent = Me
                    oChildForm.Show()
                End If

            Case "ButtonTool2"

                Dim oChildForm As Form2

                oChildForm = ShowChildFormCheck("Form2")

                If oChildForm Is Nothing Then
                    oChildForm = New Form2
                    oChildForm.MdiParent = Me
                    oChildForm.Show()

                End If

        End Select
    End Sub

    Private Sub UltraTabbedMdiManager1_TabSelected(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinTabbedMdi.MdiTabEventArgs) Handles UltraTabbedMdiManager1.TabSelected
        SetChildToolButton(UltraTabbedMdiManager1.ActiveTab.Form)
    End Sub

    Private Sub UltraTabbedMdiManager1_TabClosed(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinTabbedMdi.MdiTabEventArgs) Handles UltraTabbedMdiManager1.TabClosed
        If UltraTabbedMdiManager1.ActiveTab Is Nothing OrElse UltraTabbedMdiManager1.TabGroups.Count <= 0 Then
            If oChildRibbonGroup IsNot Nothing AndAlso _
                UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Contains(oChildRibbonGroup) = True Then
                UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Remove(oChildRibbonGroup)
            End If
        End If
    End Sub

    Private oChildRibbonGroup As Infragistics.Win.UltraWinToolbars.RibbonGroup

    Private Function ShowChildFormCheck(ByVal psFormName As String) As Form

        For Each oChildForm As System.Windows.Forms.Form In Me.MdiChildren

            If oChildForm.Name.Equals(psFormName) Then
                oChildForm.Focus()
                Return oChildForm
            End If
        Next

        Return Nothing

    End Function

    Public Sub SetChildToolButton(ByRef poForm As System.Windows.Forms.Form)

        If oChildRibbonGroup Is Nothing Then
            oChildRibbonGroup = New Infragistics.Win.UltraWinToolbars.RibbonGroup("ChildribbonGroup")
        Else
            If UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Contains(oChildRibbonGroup) = True Then
                UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Remove(oChildRibbonGroup)
            End If
        End If

        'oChildRibbonGroup = UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Add("ChildribbonGroup")

        oChildRibbonGroup.ResetTools()
        'oChildRibbonGroup = New Infragistics.Win.UltraWinToolbars.RibbonGroup("ChildribbonGroup")
        oChildRibbonGroup.Caption = "ChildribbonGroup"

        Try

            Dim oToolbar As Infragistics.Win.UltraWinToolbars.UltraToolbar
            oToolbar = CType(poForm, Object).GetChildToolbar

            For Each oTool As Object In oToolbar.Tools
                oTool.InstanceProps.MinimumSizeOnRibbon = Infragistics.Win.UltraWinToolbars.RibbonToolSize.Large
                oChildRibbonGroup.Tools.AddRange(New Infragistics.Win.UltraWinToolbars.ToolBase() {oTool})

                If oTool.InstanceProps.IsFirstInGroup = True Then
                    'MsgBox("IsFirstInGroup")
                End If

            Next

            UltraToolbarsManager1.Ribbon.Tabs("Mdiribbon").Groups.Add(oChildRibbonGroup)
            oChildRibbonGroup.Visible = True

            'UltraToolbarsManager1.RefreshMerge()

        Catch ex As Exception

        End Try


    End Sub



End Class
